function dhm(ms){
    days = Math.floor(ms / (24*60*60*1000));
    if(days < 10)days = '0'+days;
    daysms=ms % (24*60*60*1000);
    hours = Math.floor((daysms)/(60*60*1000));
    if(hours < 10)hours = '0'+hours;
    hoursms=ms % (60*60*1000);
    minutes = Math.floor((hoursms)/(60*1000));
    if(minutes < 10)minutes = '0'+minutes;
    minutesms=ms % (60*1000);
    sec = Math.floor((minutesms)/(1000));
    if(sec < 10)sec = '0'+sec;
    if(parseInt(days) > 0)
		return days+":"+hours+":"+minutes+":"+sec;
	if(parseInt(hours) > 0)
		return hours+":"+minutes+":"+sec;
	if(parseInt(minutes) > 0)
		return minutes+":"+sec;
	if(parseInt(sec) > 0)
		return sec;
}

function detailsClicked(){
	ui.activeDevice = $(this).attr('rel').replace(/:/g, "_");
	$('#gaugeview').show();
	$('#deleteview').hide();
	$('#back').show();
	$('#edit').show();
	$('#calendar').show();
	$('#gauge-button').show();
	$('#scan').hide();
	$('#devices').hide();
	$('#device-name').val(app.devices[ui.activeDevice].name);

	$('.marker').removeClass('active');
	if( app.devices[ui.activeDevice].voltType == 0 ){
		$('#vt0').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 1 ){
		$('#vt1').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 2 ){
		$('#vt2').addClass('active');
	}
}
				
var ui = {
	activeDevice:0,
	gaugeTitle:{'de':{
					'fullydischarged':'Batterie ist tiefentladen',
					'discharged':'Batterie ist entladen',
					'partiallycharged':'Batterie ist teil geladen',
					'charged':'Batterie ist geladen'},
				'en':{
					'fullydischarged':'battery is fully discharged',
					'discharged':'battery is discharged',
					'partiallycharged':'battery is partially charged',
					'charged':'battery is charged'}
	},	
	minValues: [5.95,12.00,24.00],
	maxValues: [6.30,12.55,25.05],
	highlights:[[
					 { from : 5.95,   to : 6.01, color : '#9d0d15'},
					 { from : 6.01,   to : 6.05, color : '#e95d0f'},
					 { from : 6.05,   to : 6.25, color : '#bdbf0d'},
					 { from : 6.25,   to : 6.30, color : '#41a62a'}
				],[
					{ from : 12.00,   to : 12.03, color : '#9d0d15'},
					{ from : 12.03,   to : 12.09, color : '#e95d0f'},
					{ from : 12.09,   to : 12.51, color : '#bdbf0d'},
					{ from : 12.51,   to : 12.55, color : '#41a62a'}
				],[
					{ from : 24.00,   to : 24.04, color : '#9d0d15'},
					{ from : 24.04,   to : 24.19, color : '#e95d0f'},
					{ from : 24.19,   to : 25.00, color : '#bdbf0d'},
					{ from : 25.00,   to : 25.05, color : '#41a62a'}
				]
	],
	statusTexts:{
		'de':{
			'out_of_reach':'außer Reichweite',
			'closed':'außer Reichweite',
			'found':'außer Reichweite',
			'connected':'in Reichweite',
			'discovered':'in Reichweite',
			'subscribed':'in Reichweite',
			'error':'außer Reichweite',
			'subscribedResult':'in Reichweite'
		},
		'en':{
			'out_of_reach':'out of reach',
			'closed':'out of reach',
			'found':'out of reach',
			'connected':'in reach',
			'discovered':'in reach',
			'subscribed':'in reach',
			'error':'out of reach',
			'subscribedResult':'in reach'
		}
	},
	statusClass:{
		'out_of_reach':'disconnected',
		'closed':'disconnected',
		'found':'inreach',
		'connected':'connected',
		'discovered':'connected',
		'subscribed':'connected',
		'error':'error',
		'subscribedResult':'receiving'

	},
	voltTexts:[
		'6','12','24'
	],
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
		$('#text').html('<p>Ready</p>');
		$('#scan').click(app.startScan);
		$('#logo').click(function(){
/*
			if($('#debug').is(':visible')){
				$('#debug').hide();
			}
			else{
				$('#debug').show();
			}
*/
		});
		$('#back').on('click', function(){
			$('#gaugeview').hide();
			$('#deleteview').hide();
			$('#back').hide();
			$('#scan').show();
			$('#edit').hide();
			$('#calendar').hide();
			$('#gauge-button').hide();
			$('#devices').show();
			$('#editview').hide();
			$('#calendarview').hide();
			$('#bt-activate').hide();
			$('#welcomeview').hide();
			ui.updateDevicesView(false);
		});
		$('#edit').on('click', function(){
			$('#gaugeview').hide();
			$('#deleteview').hide();
			$('#back').show();
			$('#scan').hide();
			$('#edit').show();
			$('#calendar').show();
			$('#gauge-button').show();
			$('#devices').hide();
			$('#editview').show();
			$('#calendarview').hide();
			$('#welcomeview').hide();
			ui.updateDevicesView(false);
		});
		$('.gauge-inactive').on('click', function(){
			$('#gaugeview').show();
			$('#back').show();
			$('#scan').hide();
			$('#devices').hide();
			$('#editview').hide();
			$('#calendarview').hide();
			ui.updateDevicesView(false);
		});
		$('#calendar').on('click', function(){
			$('#calendarview').show();
			$('#gaugeview').hide();
			$('#deleteview').hide();
			$('#back').show();
			$('#edit').show();
			$('#calendar').show();
			$('#gauge-button').show();
			$('#scan').hide();
			$('#devices').hide();
			$('#editview').hide();
			$('#welcomeview').hide();
			ui.updateDevicesView(false);
		});
		$('#gauge-button').on('click', function(){
			$('#gaugeview').show();
			$('#deleteview').hide();
			$('#back').show();
			$('#scan').hide();
			$('#edit').show();
			$('#calendar').show();
			$('#gauge-button').show();
			$('#devices').hide();
			$('#editview').hide();
			$('#calendarview').hide();
			$('#welcomeview').hide();
			ui.updateDevicesView(false);
		});
		$('.btactivate').on('click', function(){
			app.enable();
		});
		
		$('.save').on('click', function(){
			app.devices[ui.activeDevice].name = $('#device-name').val();
			if($('.select-volt .active').length == 0){
				app.devices[ui.activeDevice].voltType = '?';
			}
			else{
				app.devices[ui.activeDevice].voltType = $('.select-volt .active').attr('rel');
			}
			ui.updateDevicesView(false);
		});
		$('.savedate').on('click', function(){
			app.devices[ui.activeDevice].scans.push({date:Date.now(),volt:app.devices[ui.activeDevice].volt});
			if(app.devices[ui.activeDevice].scans.length > 5){
				var scans = [];
				for( var key3 in app.devices[ui.activeDevice].scans ){
					if(key3 == 0)continue;
					scans[(key3-1)] = app.devices[ui.activeDevice].scans[key3];
				}
				app.devices[ui.activeDevice].scans = scans;
			}
			ui.updateDevicesView(false);
		});
		$('.deletedevice').on('click', function(){
			app.deleteDevice();			
			app.toDelete = false;
			ui.updateDevicesView(false);
			$('#gaugeview').hide();
			$('#back').hide();
			$('#scan').show();
			$('#edit').hide();
			$('#calendar').hide();
			$('#gauge-button').hide();
			$('#devices').show();
			$('#editview').hide();
			$('#calendarview').hide();
			$('#deleteview').hide();
			$('#welcomeview').hide();
		});
		$('.welcomeok').on('click', function(){
			localStorage.setItem("firstTime", 1);
			$('#scan').show();
			$('#welcomeview').hide();
		});
		
		$('.forum').on('click', function(){
			window.open('http://bg.hoehne-media.de', '_blank', 'location=yes');
		});
		$('.homepage').on('click', function(){
			window.open('http://www.battery-guard.net', '_blank', 'location=yes');
		});
		$('.marker').on('click', function(){
			$('.marker').removeClass('active');
			$(this).addClass('active');
		});
		ui.updateDevicesView(true);
        ui.setGaugeArray();
        ui.gauge.draw();
    },
	updateDevicesView:function(loop){
		if(objHasProps(app.devices)){
			localStorage.setItem("devices12", JSON.stringify(app.devices));
		}
		$('#devices').html('');
		var devices = app.getDevices();
		
		for(var key in devices){
			var deviceElement = $('<div class="device" rel="'+key+'">');

			var deviceDeleteElement = $('<div class="delete" rel="'+key+'"></div>');
			deviceDeleteElement.on('click', function(){
					app.toDelete = $(this).attr('rel').replace(/_/g, ":");
					ui.updateDevicesView();
					$('#gaugeview').hide();
					$('#back').show();
					$('#scan').hide();
					$('#edit').hide();
					$('#calendar').hide();
					$('#gauge-button').hide();
					$('#devices').hide();
					$('#editview').hide();
					$('#calendarview').hide();
					$('#deleteview').show();
					$('#welcomeview').hide();
				}
			);
			deviceElement.append(deviceDeleteElement);
			
			var status = ui.statusClass[devices[key].status.replace(/ /g, "_")];
			var statusText = ui.statusTexts[app.language]['out_of_reach'];			
			if(typeof(ui.statusTexts[app.language][devices[key].status.replace(/ /g, "_")]) != 'undefined'){
				statusText = ui.statusTexts[app.language][devices[key].status.replace(/ /g, "_")];
			}
			if(ui.voltTexts[devices[key].voltType] == '?'){
				voltText = '?';
			}
			else{
				voltText = ui.voltTexts[devices[key].voltType];
			}
			var chargingState = ui.getChargingState(devices[key]);
			var lastSignalTime = parseInt(( Date.now() - devices[key].time ) );

			if( lastSignalTime > 604800000 ){
				var heartBeatTextDe = 'über eine Woche';
				var heartBeatTextEn = 'more than a week';
			}
			else{
				heartBeatText = dhm(lastSignalTime);
				if(typeof(heartBeatText) == 'undefined')heartBeatText = '00';
			}

			if(typeof(voltText) == 'undefined')voltText = '?';

			var deviceInfoElement = $('<div class="device-info" rel="'+key+'"><div class="device-name">'+devices[key].name+'</div><div class="clear"></div><div class="device-volt"><p class="status '+status+'">'+statusText+'</p><p class="german">'+voltText+' V Batterie</p><p class="english">'+voltText+' V Battery</p></div><div class="device-status"><span class="german '+status+'"></span><span class="english '+status+'"></span></div></div>');
			deviceInfoElement.on('click', detailsClicked);
			deviceElement.append(deviceInfoElement);
			var color = chargingState.state;			
			if( ( Date.now() - devices[key].time )  > 17280000){
				color = 'grey';
			}
			var deviceDetailsButtonElement = $('<div class="device-details-button '+color+'" rel="'+key+'"></div>');
			
			deviceDetailsButtonElement.on('click', detailsClicked);
			deviceElement.append(deviceDetailsButtonElement);
			$('#devices').append(deviceElement);
		}

		$('#btactive').html(app.btactive);
		$('#btpermission').html(app.btpermission);
		$('#lcenabled').html(app.lcenabled);
		$('#scanning').html(app.scanning);
		$('.device-info').width($('body').width()-115);
		
		if(ui.activeDevice != 0){
			
			var chargingStateActive = ui.getChargingState(devices[ui.activeDevice]);
			$('#chargingstate').html(ui.gaugeTitle[app.language][chargingStateActive.state]);

			var statusText = ui.statusTexts[app.language]['out_of_reach'];			
			if(typeof(ui.statusTexts[app.language][devices[ui.activeDevice].status.replace(/ /g, "_")]) != 'undefined'){
				statusText = ui.statusTexts[app.language][devices[ui.activeDevice].status.replace(/ /g, "_")];
			}
			var status = ui.statusClass[devices[ui.activeDevice].status.replace(/ /g, "_")];
			$('#gaugeview').attr('class', chargingStateActive.state);
			$('#status').html(statusText);
			$('#status').attr('class', status);
			$('#gauge-device-name').html(devices[ui.activeDevice].name);
			if( devices[ui.activeDevice].voltType == '?'){
				voltText = '?';
			}
			else{
				voltText = ui.voltTexts[devices[ui.activeDevice].voltType];
			}
			
			if( devices[ui.activeDevice].volt == '?'){
				ui.gauge.setValue(0);
			}
			else{
				ui.gauge.setValue(devices[ui.activeDevice].volt);
			}
			$('#gauge-volt').html(voltText+'V');
			var gaugeWidth;
			if( $(window).width() > $(window).height() ){
				gaugeWidth = ( $(window).height() / 1.6 );
			}
			else{
				gaugeWidth = ( $(window).height() * 0.5 );
			}
			if( devices[ui.activeDevice].volt != '?' && devices[ui.activeDevice].voltType != '?'){
				ui.gauge.updateConfig({
					width       : gaugeWidth,
					height      : gaugeWidth,
					title       : ui.gaugeTitle[app.language][devices[ui.activeDevice].voltType], 
					minValue    : ui.minValues[devices[ui.activeDevice].voltType],
					maxValue    : ui.maxValues[devices[ui.activeDevice].voltType],
					highlights  : ui.highlights[devices[ui.activeDevice].voltType]
				});
			}
			if( devices[ui.activeDevice].scans.length == 0 ){
				$('#dates').html('<span class="english">no saved measurements</span><span class="german">keine gespeicherten Messungen</span>');
			}
			else{
				$('#dates').html('');
				for(var key2 in devices[ui.activeDevice].scans){
					var chargingState = ui.getChargingState({voltType:devices[ui.activeDevice].voltType,volt:devices[ui.activeDevice].scans[key2].volt})
					$('#dates').append('<p class="'+chargingState.state+'"><span style="display:inline-block;width:50%;text-align:left;" >'+(new Date(devices[ui.activeDevice].scans[key2].date).getFullYear())+'.'+(new Date(devices[ui.activeDevice].scans[key2].date).getMonth()+1)+'.'+(new Date(devices[ui.activeDevice].scans[key2].date).getDate())+' '+(new Date(devices[ui.activeDevice].scans[key2].date).getHours())+':'+(new Date(devices[ui.activeDevice].scans[key2].date).getMinutes())+'</span><span style="display:inline-block;width:50%;text-align:right;">'+devices[ui.activeDevice].scans[key2].volt+'</span></p>');
				}
			}			
		}
		if(app.toDelete !== false){
			$('#delete-device-name').html(devices[app.toDelete.replace(/:/g, "_")].name);
		}
		if(loop){
			ui.updateDVTimer = setTimeout(function(){ui.updateDevicesView(true)}, 1000);
		}
		
	},
	showBTEnable:function(){
		$('#calendarview').hide();
		$('#deleteview').hide();		
		$('#gaugeview').hide();
		$('#back').hide();
		$('#scan').hide();
		$('#devices').hide();
		$('#editview').hide();
		$('#bt-activate').show();
	},
	showWelcome:function(){
		$('#welcomeview').show();
		$('#back').hide();
		$('#scan').hide();
	},	
	showDevices:function(){
		$('#calendarview').hide();
		$('#deleteview').hide();
		$('#gaugeview').hide();
		$('#back').hide();
        $('#back').hide();
        $('#scan').show();
        $('#edit').hide();
        $('#calendar').hide();
		$('#devices').show();
		$('#editview').hide();
		$('#bt-activate').hide();
		$('#welcomeview').hide();
	},
	getChargingState:function(device){
		if(device.voltType == 0){
			if( device.volt < 6.01){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 6.05){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 6.25){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			return { state:'charged', color:'#41a62a' }
			
		}
		if(device.voltType == 1){
			if( device.volt < 12.03){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 12.09){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 12.51){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			if( device.volt < 16){
				return { state:'charged', color:'#41a62a' }
			}		
		}
		if(device.voltType == 2){
			if( device.volt < 24.04){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 24.19){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 25.00){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			if( device.volt < 30){
				return { state:'charged', color:'#41a62a' }
			}
		}
		return { state:'gray', color:'gray' };
	},	
    setGaugeArray: function (){
        //Gauge erzeugen
        var gaugeWidth;
        if( $(window).width() > $(window).height() ){
			gaugeWidth = ( $(window).height() / 1.6 );
		}
		else{
			gaugeWidth = ( $(window).height() * 0.5 );
		}
    	ui.gauge = new Gauge({
    		renderTo    : 'gauge',
    		width       : gaugeWidth,
            height      : gaugeWidth,
    		glow        : true,
    		units       : 'Volt',
    		title       : '?',
    		minValue    : 5.95,
    		maxValue    : 6.3,
    		majorTicks  : false,
    		minorTicks  : 2,
    		strokeTicks : false,
            animation : { delay    : 10,
    			          duration : 1,
    			          fn       : 'cycle' },
    		highlights  : ui.highlights[0] ,
    		colors      : {
    			plate      : '#222',
    			majorTicks : '#f5f5f5',
    			minorTicks : '#ddd',
    			title      : '#fff',
    			units      : '#ccc',
    			numbers    : '#FFF',
    			needle     : { start : 'rgba(240, 128, 128, 1)', end : 'rgba(255, 160, 122, .9)' }
    		}
    	});
    	ui.gauge.setValue(0);
    }
};


window.onload = function(){
	ui.initialize();
	if($(window).width() > $(window).height()){
		$('body').addClass('portrait');
	}
	else{
		$('body').removeClass('portrait');		
	}
}

window.onresize = function(){
	
	if($(window).width() > $(window).height()){
		$('body').addClass('portrait');
	}
	else{
		$('body').removeClass('portrait');		
	}
	ui.updateDevicesView(false);
}

