/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 function objHasProps(obj){
    var i = 0;
    for(var key in obj){
        ++i;
    }

    return i;
}

var heartRateServiceUuid = "1814";
var heartRateMeasurementCharacteristicUuid = "2a53";
var clientCharacteristicConfigDescriptorUuid = "2a56";
    
var app = {
	devices:{},
	btactive:null,
	btpermission:null,
	lcenabled:null,
	scanning:null,
	enableTries:0,
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
		$('#scan').click(app.btInit);
		document.addEventListener("pause", app.pause, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {

		app.btInit();
    },
    pause:function(){
		$('#text').html('<p>pause</p>');
		for(var key in app.devices){
			var paramsObj = {"address": app.devices[key].address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
			bluetoothle.close(app.closeSuccess, app.closeError, {address:app.devices[key].address});
		}
	},
    btInit:function(){

		$('#text').append('<p>f:btInit</p>');
		var storedDevices = JSON.parse(localStorage.getItem("devices"));

		console.log(storedDevices);
		if(objHasProps(storedDevices)){
			$('#text').append('<p>stored devices loaded: </p>');
			console.log(storedDevices);
			app.devices = storedDevices;
		}
		console.log(app.devices);
		for(var key in app.devices){
			console.log(key);
			//app.devices[key].status = 'not found';
		}
		app.updateDevicesView();
		bluetoothle.isInitialized(app.isInitialized);
		scanTimer = setTimeout(app.btInit, 120000);
	},
	isInitialized:function(params){
		$('#text').append('<p>f:isInitialized</p>');
		if(params.isInitialized === true){
			app.btactive = 'initialized';
			app.updateDevicesView();
			console.log(params);
			app.checkPermissions();
		}
		else{
			bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
		}
		
	},
	initializeSuccess:function(params){
		$('#text').append('<p>f:initializeSuccess</p>');
		console.log(params);
		if(params.status == "enabled"){
			$('#text').append("<p>Bluetooth initialize success</p>");
			app.btactive = 'initialized';
			app.updateDevicesView();
			console.log(params);
			app.checkPermissions();
		}
		else{
			$('#text').append("<p>Bluetooth is not enabled</p>");
			app.btactive = 'disabled';
			$('#text').append("<p>Try to enable</p>");
			app.enable();
		}
	},
	initializeError:function(params){
		$('#text').append('<p>f:initializeSuccess</p>');
		$('#text').append("<p>Bluetooth initialize error: "+params.message+"</p>");
		app.btactive = 'initialize error';
		app.updateDevicesView();
		console.log(params);
	},
	enable:function(){
		if( app.enableTries < 5 ){
			bluetoothle.enable(
				function(params){

				},function(params){
					if(params.error == 'disable'){
						app.enableTries = 5;
						bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
					}
					$('#text').append("<p>Bluetooth enable failed</p>");
					app.btactive = 'disabled';
					console.log(params);
					app.updateDevicesView();
					app.error('Bluetooth enable failed'+params.message);
			});
			app.enableTries ++;
			scanTimer = setTimeout(app.enable, 5000);
			
		}
	},
	checkPermissions:function(){
		$('#text').append("<p>f:checkPermissions</p>");
		bluetoothle.hasPermission(app.hasPermissionSuccess);
	},
	hasPermissionSuccess:function(params){
		$('#text').append("<p>f:hasPermissionSuccess</p>");
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			app.updateDevicesView();
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
			app.updateDevicesView();
		}
		else{
			bluetoothle.requestPermission(app.requestPermissionSuccess, app.requestPermissionError);
		}
	},
	requestPermissionSuccess:function(params){
		$('#text').append("<p>f:requestPermissionSuccess</p>");
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			app.updateDevicesView();
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
		}
		else{
			$('#text').append('<p>Could not request permissions '+params.message+'. Try to scan anyway.</p>');
			console.log('Could not request permissions. Try to scan anyway.');
			console.log(params);
			app.startScan();
		}
	},
    isLocationEnabledSuccess: function(params) {
		app.lcenabled = 'enabled';
		$('#text').append("<p>f:isLocationEnabledSuccess</p>");
        app.startScan();
    },
    isLocationEnabledError: function(params) {
		$('#text').append("<p>f:isLocationEnabledError</p>");
		app.lcenabled = 'disabled';
		app.updateDevicesView();
        bluetoothle.requestLocation(app.requestLocationSuccess, app.requestLocationError);
        $('#text').append('<p>Could not check location'+params.message+'. Try to scan anyway.</p>');
        console.log('Could not check location. Try to scan anyway.');
		console.log(params);
        app.startScan();
    },
    requestLocationSuccess: function(params) {
		$('#text').append("<p>f:requestLocationSuccess</p>");
		app.lcenabled = 'enabled';
		app.updateDevicesView();
        app.startScan();
    },
    requestLocationError: function(params) {
		$('#text').append("<p>f:requestLocationError</p>");
		app.lcenabled = 'disabled';
		app.updateDevicesView();
		$('#text').append('<p>Could not request location '+params.message+'. Try to scan anyway.</p>');
        console.log('Could not request location. Try to scan anyway.');
		console.log(params);
		app.startScan();
    },
    startScan: function() {
		$('#text').append("<p>f:startScan</p>");
		console.log(app.scanning);
		if(app.scanning)return;
        bluetoothle.startScan(app.startScanSuccess, app.startScanError, {
		  "services": [
		  ],
		  "allowDuplicates": true,
		  "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
		  "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
		  "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
		  "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES,
		});
		scanTimer = setTimeout(app.stopScan, 20000);
    },
    startScanError: function(params) {
		$('#text').append("<p>f:startScanError</p>");
		app.scanning = 'error';
		$('#text').append('<p>Could not start scan '+params.message+'.</p>');
		app.updateDevicesView();
		console.log(params);
    },
    startScanSuccess: function(params) {
		console.log(params);
		$('#text').append("<p>f:startScanSuccess</p>");
		$('#text').append('<p>'+params.status+'</p>');
		
		app.updateDevicesView();
		if(params.status == 'scanStarted' ){
			app.scanning = 'scanning';
			
		}
		if(params.status == 'error' ){
			app.devices[params.address.replace(/:/g, "_")].status = params.status;
			app.scanning = false;
			//var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			//bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
		}
		if(params.status == 'scanResult' && params.name == 'BLE-VoltageCheck'){
			$('#text').append('<p>device found:'+params.address+'</p>');
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = params.status;
			}
			else{
				app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:'',scans:[],status:params.status};
			}
			$('#text').append('<p>store device in db</p>');
			localStorage.setItem("devices", JSON.stringify(app.devices));
			console.log('devices');
			console.log(app.devices);
			console.log(JSON.parse(localStorage.getItem("devices")));
			$('#text').append('<p>try to connect to device '+params.address+':</p>');
			bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": params.address});
			//bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
			
		}
		app.updateDevicesView();
    },
    isConnectedSuccess:function(params){
		$('#text').append("<p>f:connectSuccess</p>");
		if(params.isConnected === true){
			app.devices[params.address.replace(/:/g, "_")].status = 'connected';
			localStorage.setItem("devices", JSON.stringify(app.devices));
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
		else{
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			localStorage.setItem("devices", JSON.stringify(app.devices));
			bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
		}		
		app.updateDevicesView();
	},
    isConnectedError:function(params){
		app.devices[params.address.replace(/:/g, "_")].status = 'not connected';
		localStorage.setItem("devices", JSON.stringify(app.devices));
		app.updateDevicesView();
		$('#text').append("<p>f:isConnectedError</p>");
		$('#text').append('<p>Could not check if device '+params.address+' is connectet: '+params.message+'. Try to connect.</p>');
        console.log('Could not check if device is connectet.');
		console.log(params);
		bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
	},
    connectSuccess:function(params){
		$('#text').append("<p>f:connectSuccess</p>");
		$('#text').append('<p>status:'+params.status+'</p>');
		$('#text').append('<p>device:'+params.address+'</p>');
		console.log('connectSuccess');
		console.log(params.status);
		console.log(params.address);
		if(params.status == 'connected'){			
			var paramsObj = {"address": params.address};
            bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
		}
		if(params.status == 'disconnected'){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.unsubscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
			bluetoothle.close(app.closeSuccess, app.closeError, params);
		}
		app.devices[params.address.replace(/:/g, "_")].status = params.status;
		localStorage.setItem("devices", JSON.stringify(app.devices));

		app.updateDevicesView();
	},
    connectError:function(params){
		$('#text').append("<p>f:connectError</p>");
		console.log(params);
		$('#text').append('<p>Could not connect device: '+params.message+'</p>');
        console.log('Could not connect device.');
		console.log(params);
		app.devices[params.address.replace(/:/g, "_")].status = 'connection failed';
		localStorage.setItem("devices", JSON.stringify(app.devices));

		var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
		//bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
		bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
		//app.error('connection failed');
	},
    stopScan:function(params){
		$('#text').append("<p>f:stopScan</p>");
		bluetoothle.stopScan(app.stopScanSuccess, app.stopScanError);
		app.scanning = false;
		app.updateDevicesView();
	},
    stopScanSuccess:function(params){
		$('#text').append("<p>f:stopScanSuccess</p>");
	},
    stopScanError:function(params){
		$('#text').append("<p>f:stopScanError</p>");
		$('#text').append('<p>Could not stop scan '+params.message+'.</p>');
        console.log('Could not stop scan.');
		console.log(params);
	},
    closeSuccess:function(params){
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			localStorage.setItem("devices", JSON.stringify(app.devices));
			app.updateDevicesView();
		}
		$('#text').append("<p>f:closeSuccess</p>");
	},
    closeError:function(params){
		$('#text').append("<p>f:closeError</p>");
		$('#text').append('<p>Could not close connection '+params.message+'.</p>');
        console.log('Could not close connection.');
		console.log(params);
	},
	isDiscoveredSuccess:function(params){
		$('#text').append("<p>f:discoverSuccess</p>");
		if(params.isDiscovered === true){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			$('#text').append('<p>try to subscribe</p>');
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
		}
		else{
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
	},
	isDiscoveredError:function(params){
		$('#text').append("<p>f:isDiscoveredError</p>");
		$('#text').append('<p>Could not check if services is discovered: '+params.message+'.</p>');
		app.devices[params.address.replace(/:/g, "_")].status = '?';
		localStorage.setItem("devices", JSON.stringify(app.devices));
		app.updateDevicesView();
	},
	discoverSuccess:function(params){
		$('#text').append("<p>f:discoverSuccess</p>");
		console.log(params);
		if (params.status == "discovered")
        {
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			console.log(paramsObj);
			$('#text').append('<p>try to subscribe</p>');
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
			app.devices[params.address.replace(/:/g, "_")].status = 'discovered';
			localStorage.setItem("devices", JSON.stringify(app.devices));
			app.updateDevicesView();
		}
		app.updateDevicesView();
	},
	discoverError:function(params){
		$('#text').append("<p>f:discoverError</p>");
		$('#text').append('<p>Could not discover services '+params.message+'.</p>');
		app.devices[params.address.replace(/:/g, "_")].status = '?';
		localStorage.setItem("devices", JSON.stringify(app.devices));
		app.updateDevicesView();
        console.log('Could not discover services.');
		console.log(params);
	},
	subscribeSuccess:function(params){
		$('#text').append("<p>f:subscribeSuccess</p>");
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) !== 'object'){
			app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:'',scans:[],status:params.status};
		}
		else{
			app.devices[params.address.replace(/:/g, "_")].status = params.status;
		}
		localStorage.setItem("devices", JSON.stringify(app.devices));
		/*
		console.log('devices');
		console.log(app.devices);
		console.log(JSON.parse(localStorage.getItem("devices")));
		*/
		app.updateDevicesView();
		$('#text').append('<p>status:'+params.status+'</p>');
		$('#text').append('<p>device:'+params.address+'</p>');
		if (params.status == "subscribedResult")
		{
			//console.log("Subscription data received");

			//Parse array of int32 into uint8
			var bytes = bluetoothle.encodedStringToBytes(params.value);

			//Check for data
			if (bytes.length == 0)
			{
				console.log("Subscription result had zero length data");
				return;
			}

			//Get the first byte that contains flags
			var flag = bytes[0];

			//Check if u8 or u16 and get heart rate
			var hr;
			if ((flag & 0x01) == 1)
			{
				var u16bytes = bytes.buffer.slice(1, 3);
				var u16 = new Uint16Array(u16bytes)[0];
				hr = u16;
			}
			else
			{
				var u8bytes = bytes.buffer.slice(1, 2);
				var u8 = new Uint8Array(u8bytes)[0];
				hr = u8;
			}

			var hr2 = hr/1000;
			//console.log("Volt: " + (hr/1000).toString());
			app.devices[params.address.replace(/:/g, "_")].volt = hr2;
			localStorage.setItem("devices", JSON.stringify(app.devices));
			/*
			console.log('devices');
			console.log(app.devices);			
			console.log(JSON.parse(localStorage.getItem("devices")));
			*/
		}
		app.updateDevicesView();
	},
	subscribeError:function(params){
		$('#text').append("<p>f:subscribeError</p>");
		//bluetoothle.disconnect(disconnectSuccess, disconnectError, senders[active_sender].obj);
		$('#text').append('<p>Could not subscribe service  '+params.message+'.</p>');
        console.log('Could not subscribe service.');
		console.log(params);
	},
	unsubscribeSuccess:function(params){
		$('#text').append("<p>f:unsubscribeSuccess</p>");
	},
	unsubscribeError:function(params){
		$('#text').append("<p>f:unsubscribeError</p>");
		$('#text').append('<p>Could not unsubscribe service  '+params.message+'.</p>');
	},
	updateDevicesView:function(){
		$('#volts').html('');
		for(var key in app.devices){
			$('#volts').append('<p>address:'+app.devices[key].address+'<br />Status:'+this.devices[key].status+'<br />Volt:'+this.devices[key].volt+'</p>');
		}
		$('#btactive').html(app.btactive);
		$('#btpermission').html(app.btpermission);
		$('#lcenabled').html(app.lcenabled);
		$('#scanning').html(app.scanning);
	},
	checkConnection:function(){
		$('#text').append("<p>f:checkConnection</p>");
		for(var key in app.devices){
			$('#text').append("<p>"+app.devices[key].address+' : '+app.devices[key].status+"</p>");
			if(app.devices[key].status == 'closed' || app.devices[key].status == 'not connected' || app.devices[key].status == '?'){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
			}
			if(app.devices[key].status == 'connected'){
				var paramsObj = {"address": app.devices[key].address};
				bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
			}

		}
		scanTimer = setTimeout(app.checkConnection, 10000);
	},
			
    error: function(text) {
        $('#text').append('<p>App ended on error'+text+'</p>');
    }
};

app.initialize();
scanTimer = setTimeout(app.checkConnection, 10000);
scanTimer = setTimeout(app.btInit, 120000);
window.onerror = function(message, url, lineNumber) {
	$('#text').append("Error: "+message+" in "+url+" at line "+lineNumber);
}
