
function objHasProps(obj){
    var i = 0;
    for(var key in obj){
        ++i;
    }
    return i;
}

var app = {
	devices:{},
	btactive:null,
	btpermission:null,
	lcenabled:null,
	scanning:null,
	enableTries:0,
	connectionLoop:false,
	language:'en',
	isFake:false,
	fakeInit:false,
	toDelete:false,
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);        
    },
    checkLang:function(){

        if(typeof(navigator.globalization) != 'undefined'){
			navigator.globalization.getPreferredLanguage(
				function(lang){

					if(lang.value.length > 2){
						if(lang.value.substring(0,2).toLowerCase() == 'de'){
							$('body').removeClass('english').addClass('german');
							app.language = 'de';
					    }
					    else{
							$('body').removeClass('german').addClass('english');
							app.language = 'en';
						}
					}
				},
				function(){

				}
			);
		}
	},
    onDeviceReady: function() {
		document.addEventListener("pause", app.pause, false);
		document.addEventListener("resume", app.resume, false);		
		app.checkLang();
		app.btInit();
    },
    pause:function(){
		app.stopScan();
		clearTimeout(app.checkTimer);
		clearTimeout(app.scanTimer);
		clearTimeout(ui.updateDVTimer);
		app.connectionLoop=false;
		for(var key in app.devices){
			var paramsObj = {"address": app.devices[key].address,"service":"1814", "characteristic":"2a53"};
			if(app.devices[key].status == 'subscribedResult'){
				bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
			}
			if(app.devices[key].status != 'out of reach'){
				bluetoothle.close(app.closeSuccess, app.closeError, {address:app.devices[key].address});
			}
		}
	},
    resume:function(){
		app.checkLang();
		app.btInit();
		ui.updateDevicesView(true);
	},	
    btInit:function(){
		$('#bt-activate .frame').html('');
		ui.showDevices();
		if(localStorage.getItem("firstTime") == null){
			ui.showWelcome();
			
		}
		var oldDevices = JSON.parse(localStorage.getItem("devices"));
		if(objHasProps(storedDevices)){
			localStorage.removeItem("devices");
		}
		
		var storedDevices = JSON.parse(localStorage.getItem("devices12"));
		if(objHasProps(storedDevices)){
			app.devices = storedDevices;
		}

		for(var key in app.devices){
			app.devices[key].status = 'out of reach';
			if(typeof(app.devices[key].voltType) == 'undefined'){
				app.devices[key].voltType = '?';
			}
		}
		bluetoothle.isInitialized(app.isInitialized);
	},
	isInitialized:function(params){
		if(params.isInitialized === true){
			app.btactive = 'initialized';
			app.checkPermissions();
		}
		else{
			bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
		}		
	},
	initializeSuccess:function(params){
		if(params.status == "enabled"){
			app.btactive = 'initialized';
			app.checkPermissions();
		}
		else{
			app.btactive = 'disabled';
			ui.showBTEnable();
		}
	},
	initializeError:function(params){
		app.btactive = 'initialize error';
	},
	enable:function(){
		if( app.enableTries < 5 ){
			bluetoothle.enable(
				function(params){
					ui.showDevices();
					app.checkPermissions();
				},function(params){
					if(params.error == 'disable'){
						$('#bt-activate .frame').append('<p><span class="english">success</span><span class="german">erfolgreich</span></p>');
						ui.showDevices();
						app.enableTries = 5;
						bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
					}
					app.btactive = 'disabled';
					$('#bt-activate .frame').append('<p>&nbsp;</p><p><span class="english">failed</span><span class="german">fehlgeschlagen</span></p><p>&nbsp;</p><p><span class="english">'+(5-app.enableTries)+' tries follow</span><span class="german">noch '+(5-app.enableTries)+' Versuche folgen</span></p>');
			});
			app.enableTries ++;			
			setTimeout(app.enable, 5000);			
		}
		else{
			$('#bt-activate').append('<p>&nbsp;</p><p><span class="english">Cannot activate bluetooth.</span><span class="german">Kann Bluetooth nicht aktivieren.</span></p><p>&nbsp;</p><p><span class="english">'+(5-app.enableTries)+' tries follow</span><span class="german">noch '+(5-app.enableTries)+' Versuche folgen</span></p>');			
		}
	},
	checkPermissions:function(){
		bluetoothle.hasPermission(app.hasPermissionSuccess);
	},
	hasPermissionSuccess:function(params){
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			bluetoothle.isEnabled(app.isEnabled);
		}
		else{
			bluetoothle.requestPermission(app.requestPermissionSuccess, app.requestPermissionError);
		}
	},
	isEnabled:function(params){
		if(params.isEnabled){
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
		}
		else{			
			ui.showBTEnable();
		}
	},
	enableSuccess:function(params){
		ui.showDevices();
		bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
	},
	enableError:function(params){
	},
	requestPermissionSuccess:function(params){
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
		}
		else{
			app.startScan();
		}
	},
    isLocationEnabledSuccess: function(params) {
		app.lcenabled = 'enabled';
        app.startScan();
    },
    isLocationEnabledError: function(params) {
		app.lcenabled = 'disabled';
        bluetoothle.requestLocation(app.requestLocationSuccess, app.requestLocationError);
    },
    requestLocationSuccess: function(params) {
		app.lcenabled = 'enabled';
        app.startScan();
    },
    requestLocationError: function(params) {
		app.lcenabled = 'disabled';
		app.startScan();
    },
    startScan: function(){
		$('#scan').addClass('scanning');
		if(app.scanning)return;
		
		for(var key in app.devices){
			if(app.devices[key].status != 'subscribedResult'){
				app.devices[key].status = 'out of reach';
			}
		}
		
        bluetoothle.startScan(app.scanSuccess, app.startScanError, {
		  "services": [
		  ],
		  "allowDuplicates": true,
		  "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
		  "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
		  "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
		  "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES,
		});
    },
    startScanError: function(params) {
		app.scanning = 'error';
    },
    scanSuccess: function(params) {
		if(params.status == 'scanStarted' ){
			app.scanning = 'scanning';
			app.scanTimer = setTimeout(app.stopScan, 5000);
		}
		if(params.status == 'error' ){
            if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
                app.devices[params.address.replace(/:/g, "_")].status = params.status;
                app.devices[params.address.replace(/:/g, "_")].time = Date.now();
                app.scanning = false;
            }
		}
		if(params.status == 'scanResult' && params.name == 'BLE-VoltageCheck'){
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = 'found';				
				app.devices[params.address.replace(/:/g, "_")].time = Date.now();
			}
			else{
				var countDevices = 0;
				for(var key in app.devices){
					countDevices++;
				}

				if(countDevices <= 4 ){
					app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:params.address,scans:[],status:'found',time:Date.now(),working:false,voltType:'?',volt:'?'};
				}
			}
		}
    },
    getDevices:function(){
		if(app.isFake == false){
			
		}
		else{
			if( app.fakeInit == false ){
				app.devices = [];				
				app.devices['78_A5_04_69_E2_4A'] = {address:'78:A5:04:69:E2:4A',name:'AUTO DO-FF XXC',scans:[{date:1464501480636,volt:12.563},{date:1464521480636,volt:12.103},{date:1464921400636,volt:11.44},{date:1464921480636,volt:12.44}],status:'subscribedResult',time:Date.now(),working:true,voltType:'1',volt:12.563};
				app.devices['00_22_5B_00_15_10'] = {address:'00:22:5B:00:15:10',name:'YAMAHA R1',scans:[],status:'subscribedResult',time:Date.now(),working:true,voltType:'1',volt:11.243};
				app.devices['78_A5_04_69_84_7E'] = {address:'78:A5:04:69:84:7E',name:'Auto DO-XX ZZZ',scans:[],status:'closed',time:Date.now()-150000,working:true,voltType:'1',volt:12.556};
				app.devices['B4_99_4C_39_D2_DC'] = {address:'B4:99:4C:39:D2:DC',name:'BLUE CADILLAC',scans:[],status:'out of reach',time:Date.now()-11112000,working:true,voltType:'1',volt:12.314};
				app.devices['B4_99_4C_39_C6_C6'] = {address:'B4:99:4C:39:C6:C6',name:'BOAT',scans:[],status:'out of reach',time:Date.now()-1155000,working:true,voltType:'1',volt:12.334};
				app.fakeInit = true;
			}
		}
		return app.devices;
	},
    connect:function(address){
		bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": address});
	},
    isConnectedSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			return;
		}
		if(params.isConnected === true){
			app.devices[params.address.replace(/:/g, "_")].status = 'connected';
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
		else{
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
			bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
		}
		app.devices[params.address.replace(/:/g, "_")].working = true;	
	},
    isConnectedError:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			return;
		}
		$('#text').append("<p>f:isConnectedError</p>");
		$('#text').append('<p>Konnte nicht testen ob Sender  '+params.address+' verbunden: '+params.message+'. Versuche zu verbinden.</p>');
		$('#textwrapper').scrollTop($('#text').innerHeight());
		app.devices[params.address.replace(/:/g, "_")].working = true;
		bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
	},
    connectSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		if(params.status == 'connected'){			
			var paramsObj = {"address": params.address};
            bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
		}
		if(params.status == 'disconnected'){
			bluetoothle.close(app.closeSuccess, app.closeError,  {address:params.address});
		}
		app.devices[params.address.replace(/:/g, "_")].status = params.status;
		app.devices[params.address.replace(/:/g, "_")].time = Date.now();
		app.devices[params.address.replace(/:/g, "_")].working = true;
	},
    connectError:function(params){
        if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined" ){
        }
        else{
            app.devices[params.address.replace(/:/g, "_")].status = 'error';
            app.devices[params.address.replace(/:/g, "_")].working = false;
        }
            bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},
    reconnectSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		var paramsObj = {"address": params.address};
		app.devices[params.address.replace(/:/g, "_")].working = true;
		bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
	},
    reconnectError:function(params){
		bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},
    stopScan:function(params){
		$('#scan').removeClass('scanning');
		bluetoothle.stopScan(app.stopScanSuccess, app.stopScanError);
		app.scanning = false;
		if(app.connectionLoop == false){
			app.checkConnection();
		}
	},
    stopScanSuccess:function(params){
	},
    stopScanError:function(params){
	},
    closeSuccess:function(params){
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			app.devices[params.address.replace(/:/g, "_")].working = false;
		}
		
	},
    closeError:function(params){

		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].working = false;
		}
	},
	isDiscoveredSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		app.devices[params.address.replace(/:/g, "_")].working = true;
		if(params.isDiscovered === true){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
		}
		else{
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
	},
	isDiscoveredError:function(params){
		app.devices[params.address.replace(/:/g, "_")].status = 'error';		
		app.devices[params.address.replace(/:/g, "_")].working = false;
	},
	discoverSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		if (params.status == "discovered"){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
			app.devices[params.address.replace(/:/g, "_")].status = 'discovered';
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
		}		
		app.devices[params.address.replace(/:/g, "_")].working = true;
	},
	discoverError:function(params){
        if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
            app.devices[params.address.replace(/:/g, "_")].status = 'error';
            app.devices[params.address.replace(/:/g, "_")].working = false;
        }
	},
	subscribeSuccess:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);		
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}	
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) !== 'object'){
			app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:'',scans:[],status:params.status,time:Date.now()};
		}
		else{
			app.devices[params.address.replace(/:/g, "_")].status = params.status;
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
		}

		if (params.status == "subscribedResult"){
			if (app.devices[params.address.replace(/:/g, "_")].working){
			}	
			app.devices[params.address.replace(/:/g, "_")].working = false;
			//Parse array of int32 into uint8
			var bytes = bluetoothle.encodedStringToBytes(params.value);

			//Check for data
			if (bytes.length == 0){
				return;
			}

			//Get the first byte that contains flags
			var flag = bytes[0];

			//Check if u8 or u16 and get heart rate
			var hr;
			if ((flag & 0x01) == 1){
				//var u16bytes = bytes.buffer.slice(1, 3);
				//console.log( ( (((bytes[1] & 0xff) << 8) | (bytes[2] & 0xff)) ) );
				//console.log( ( (((bytes[2] & 0xff) << 8) | (bytes[1] & 0xff)) ) );	
				hr = ( (((bytes[2] & 0xff) << 8) | (bytes[1] & 0xff)) );
			}
			else{
				hr = ( (((bytes[2] & 0xff) << 8) | (bytes[1] & 0xff)) );
			}
			if(app.devices[params.address.replace(/:/g, "_")].voltType == "?"){
				if(hr < 9000 ){
					  app.devices[params.address.replace(/:/g, "_")].voltType = 0;
				}
				else if(hr >= 9000 && hr < 18000){
					 app.devices[params.address.replace(/:/g, "_")].voltType = 1;
				}
				else if(hr >= 18000 ){
					  app.devices[params.address.replace(/:/g, "_")].voltType = 2;
				}
			}
			var hr2 = hr/1000;

			app.devices[params.address.replace(/:/g, "_")].volt = hr2;
		}
	},
	subscribeError:function(params){
		var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
		//bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);		
	},
	unsubscribeSuccess:function(params){
		app.devices[params.address.replace(/:/g, "_")].working = false;
	},
	unsubscribeError:function(params){
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		app.devices[params.address.replace(/:/g, "_")].working = false;
	},
	deleteDevice:function(){
		address = app.toDelete;
		ui.activeDevice = 0;
		var paramsObj = {"address": address,"service":"1814", "characteristic":"2a53"};
		bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
		bluetoothle.close(app.closeSuccess, app.closeError, {address:address});
		delete(app.devices[address.replace(/:/g, "_")]);
	},
	checkConnection:function(){
		if(app.scanning){
			app.checkTimer = setTimeout(app.checkConnection, 3000);
			return;			
		}
		app.connectionLoop = true;
		for(var key in app.devices){			
			if(app.devices[key].status == 'subscribedResult' || app.devices[key].status == 'out of reach'){

			}
			else if( app.devices[key].status == 'found' || ( ( Date.now() - app.devices[key].time ) > 5000  && app.devices[key].status != 'closed' && app.devices[key].working == false ) ){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}
			else if( ( ( Date.now() - app.devices[key].time ) > 10000  && app.devices[key].working == false ) ){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}	
			else if( ( ( Date.now() - app.devices[key].time ) > 15000  ) ){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}	
		}		
		app.checkTimer = setTimeout(app.checkConnection, 3000);
	},			
    error: function(text) {
    }
};

app.initialize();


window.onerror = function(message, url, lineNumber) {
	alert("Error: "+message+" in "+url+" at line "+lineNumber);
}

